<template>
	<div>
		<GlobalHeader ref="header" />
		<main id="maincontent">
				<div
				v-if="false && SERVICE_ERROR_MESSAGE.message"
				role="alert"
				class="py-2 text-base leading-6 text-center text-black rounded-md bg-error-10 font-primary-font-light flex w-full items-center"
			>
				<div class="grid w-full">
					<p class="contents text-center ml-auto" >{{SERVICE_ERROR_MESSAGE.message}}</p>
					<p v-if="SERVICE_ERROR_MESSAGE.data" class="underline font-bold cursor-pointer ml-1" @click="showPayload=!showPayload">{{showPayload ? 'hide payload' : 'show payload'}} </p>
					<p v-if="showPayload" class="contents text-center ml-auto" >{{SERVICE_ERROR_MESSAGE.data}}</p>
				</div>
				<p
					tabindex="0"
					class="icon-close ml-auto mk-error-close mr-4 text-xs cursor-pointer"
					@keypress.enter="$store.commit('USER_STORE/SET_SERVICE_ERROR', '')"
					@click="$store.commit('USER_STORE/SET_SERVICE_ERROR', '')"
				></p>
				</div>
			<nuxt />
		</main>
		<GlobalFooter />
		<template v-for="(modal, index) in promoModals">
			<GlobalPromoModal
				:id="modal.id"
				:ref="`promoModal${index}`"
				:key="modal.id || index"
				:label="modal.label"
				:show-automatically="modal.showAutomatically"
				:show-again-after="modal.showAgainAfter"
				:width="modal.width"
				:height="modal.height"
				:width-desktop="modal.widthDesktop"
				:height-desktop="modal.heightDesktop"
				:content-alignment="modal.contentAlignment"
				:content-first="modal.contentFirst"
				:show-newsletter-form="modal.showNewsletterForm"
				:newsletter-button-text="modal.newsletterButtonText"
				:image-mobile="modal.imageMobile"
				:image="modal.image"
				:content-second="modal.contentSecond"
				:cta-text="modal.ctaText"
				:cta-link="modal.ctaLink"
				:cta-copy-to-clipboard="modal.ctaCopyToClipboard"
				:content-bottom="modal.contentBottom"
				:background-color="modal.backgroundColor"
			/>
		</template>
		<GlobalChatWidgetZendesk
			v-if="
				$route.path !== '/healthcare-inquiries' &&
				$route.path !== '/return-to-office' &&
				$route.path !== '/crrsa-act-education'
			"
		/>
	</div>
</template>

<script>
import GlobalHeader from '@components/global-header';
import { mapState, mapGetters } from 'vuex';
import scrollToHash from '@/utils/scroll-to-hash';
import { hydrateWhenVisible } from 'vue-lazy-hydration';

export default {
	components: {
		GlobalHeader,
		GlobalFooter: hydrateWhenVisible(() => import('@components/global-footer'), {
			observerOptions: { rootMargin: '50px' },
		}),
		GlobalPromoModal: hydrateWhenVisible(() => import('@components/global-promo-modal'), {
			observerOptions: { rootMargin: '50px' },
		}),
		GlobalChatWidgetZendesk: hydrateWhenVisible(() => import('@components/global-chat-widget-zendesk'), {
			observerOptions: { rootMargin: '50px' },
		}),
	},

	provide() {
		return { openPromoModal: this.openPromoModal, openCart: this.openCart, getHeaderHeight: this.getHeaderHeight };
	},
	middleware: 'auth',

	head() {
		const script = [];
		const style = [];
		const __dangerouslyDisableSanitizersByTagID = {};
		if ((process.server && process.env.SENTRY_RELEASE) || (process.client && window.SENTRY_RELEASE)) {
			const release = process.server ? process.env.SENTRY_RELEASE : window.SENTRY_RELEASE.id;
			script.push({
				hid: 'sentry-release',
				type: 'text/javascript',
				innerHTML: `window.SENTRY_RELEASE={id:'${release || ''}'};`,
			});
			__dangerouslyDisableSanitizersByTagID['sentry-release'] = ['innerHTML'];
		}

		return {
			titleTemplate: (titleChunk) => titleChunk || 'Molekule',
			script,
			__dangerouslyDisableSanitizersByTagID,
			style,
		};
	},
	data(){
		return{
				showPayload:false
		}
	},
	computed: {
		...mapState({
			promoModals: (state) => state.globalData.promoModals.filter((modal) => !modal.disableModal),
			antiFlicker: (state) => state.globalData.antiFlicker,
		}),
		...mapState('USER_STORE',['SERVICE_ERROR_MESSAGE']),
		...mapGetters('magento', ['cart']),
	},

	watch: {
		$route: {
			immediate: true,
			handler: 'addToCartBasedOnRoute',
		},
	},

	mounted() {
		scrollToHash(this.$route.hash, { animate: false });
	},

	methods: {
		openPromoModal(stringToAppendToAction) {
			this.$refs.promoModal0[0].open(stringToAppendToAction);
		},

		openCart() {
			this.$refs.header.openCart();
		},

		getHeaderHeight() {
			return this.$refs.header.getHeaderHeight();
		},

		async addToCartBasedOnRoute() {
			if (process.server) return;

			const getExpirationDate = (hours) => {
				const today = new Date();
				return today.setTime(today.getTime() + (hours || 24) * 60 * 60 * 1000);
			};

			const { atc: skus, 'atc-timing': atcLinkTiming } = this.$route.query;
			if (skus) {
				const { products } = this.$store.state.magento;
				const { isUSWebsite } = this.$store.state;
				let addToCartSkus = [];
				skus.split(',').forEach((skuRaw) => {
					let sku = (skuRaw || '').trim();
					const location = sku.slice(0, 2);
					const hasLocation = sku.startsWith('US:') || sku.startsWith('CA:');
					if (hasLocation) {
						if ((isUSWebsite && location !== 'US') || (!isUSWebsite && location === 'US')) return null;
						sku = sku.slice(3);
					}

					let quantity = sku.slice(-1);
					const hasQuantity = /\*\d+$/.test(sku);
					if (hasQuantity) {
						sku = sku.slice(0, -2);
					} else {
						quantity = 1;
					}

					if (products[sku] && sku) {
						for (let i = 0; i < quantity; i++) {
							addToCartSkus.push(sku);
						}
					}
				});
				addToCartSkus = addToCartSkus
					.filter(Boolean)
					.reduce(
						(obj, sku) => {
							obj[0][sku] = (obj[0][sku] || 0) + 1;
							return obj;
						},
						[{}]
					)
					.map((obj) => Object.entries(obj).map(([sku, qty]) => ({ sku, qty })))[0];

				if (addToCartSkus.length) {
					try {
						await this.$store.state.magento.initialFetchCartPromise;
						const areItemsInCart =
							this.cart &&
							this.cart.items &&
							addToCartSkus.length === this.cart.items.length &&
							addToCartSkus.every(({ sku, qty }) =>
								this.cart.items.some((item) => item.sku === sku && item.qty === qty)
							);

						if (!areItemsInCart) {
							await this.$store.dispatch('magento/CLEAR_CART');
							await this.$store.dispatch('magento/ADD_TO_CART', { items: addToCartSkus });

							// TODO: Fix Safari issue without using setTimeout
							this.$nextTick(() => setTimeout(() => this.openCart(), 1500));

							localStorage.setItem(
								'atc_link_timing',
								JSON.stringify({
									skus: addToCartSkus,
									cartUpdatedAt: this.cart.updatedAt,
									expirationDate: getExpirationDate(Number(atcLinkTiming)),
								})
							);
						} else if (areItemsInCart) {
							const currentAtcLinkTiming = localStorage.getItem('atc_link_timing');

							if (currentAtcLinkTiming) {
								localStorage.setItem(
									'atc_link_timing',
									JSON.stringify({
										skus: addToCartSkus,
										cartUpdatedAt: this.cart.updatedAt,
										expirationDate: getExpirationDate(Number(atcLinkTiming)),
									})
								);
							}
						}
					} catch (e) {
						// eslint-disable-next-line no-console
						console.error(e);
						this.$sentry.captureException(e);
					}
				}
			}
		},
	},
};
</script>

<style lang="scss">
@import './app.scss';
</style>
